'PowerBASIC adaptation of Charles Petzold's Checkers3 program from his
'Programming Windows 95' book.  This program creates a five by five grid of 25
#Compile Exe "Checkers"  'child windows on the surface of a parent 'main'
#Include "Win32api.inc"  'window.  When you left mouse button click on any
%GRID_SIZE = 5           'window in the grid the program draws a big X across
                         'the window.  The X is removed by clicking again.

Function fnChildWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CREATE
      Call SetWindowLong _   'This is the Window Procedure for all windows of
      ( _                    'the class 'Child'  In this program 25 such
        hWnd, _              'windows are created in a loop down in the Window
        0, _                 'Procedure for the Main Window (fnMainWndProc).
        0 _                  'Every CreateWindow() Call there will cause a
      )                      'WM_CREATE message to be sent here.  This procedure
      fnChildWndProc=0       'will then receive 25 WM_CREATE messages.  When the
      Exit Function          'Window Class for these windows was registered down
    Case %WM_LBUTTONDOWN     'in fnMainWndProc(), the cbWndExtra bytes member of
      Call SetWindowLong _   'the WNDCLASSEX type was set equal to four.  What
      ( _                    'this means is that every window of this class
        hWnd, _              'created will have a four byte area to store
        0, _                 'something pertaining to the program's use of the
        1 Xor GetWindowLong(hWnd,0) _ 'window.What this program is going to do
      )                      'with those four bytes is store a simple %TRUE /
      Call InvalidateRect _  '%FALSE (1/0) value there that represents whether
      ( _                    'the window has an 'X' in it or not.  When the
        hWnd, _        'program starts up all the windows are to be empty.
        Byval %NULL, _ 'Therefore, in the WM_CREATE processing the Api function
        %TRUE _        'SetWindowLong() is used to store a value of zero in this
      )                'four byte area for each window.  When you click your
      fnChildWndProc=0 'mouse button over a window this procedure will receive
      Exit Function    'a WM_LBUTTONDOWN message with the hWnd parameter
    Case %WM_PAINT     'reflecting the window which received the mouse click.
      Local hDC As Dword     'At that point what the program must do is 'toggle'
      Local ps As PAINTSTRUCT'whatever value is present in the cbWndExtra bytes
      Local rc As RECT       'to its opposite. If true, we'll want to toggle to
      Local pt As POINTAPI   'false.  If false, we'll want to toggle to true. If
      hDC=BeginPaint(hWnd,ps)'1' is Xor'ed with the XOR bit wise operator
      Call GetClientRect(hWnd,rc)   'against '0', the result is 1.  If '1' is
      If GetWindowLong(hWnd,0) Then 'Xor'ed against '1', the result is '0'.  You
         pt.x=0 : pt.y=0            'can see that done in the GetWindowLong()
         Call MoveToEx _  'call within the SetWindowLong() call in the
         ( _              'WM_LBUTTONDOWN processing.  What then finally causes
           hDC, _         'the big 'X' to crisscross the child window over
           0, _           'which a mouse click occurs is the InvalidateRect()
           0, _           'call directly after the SetWindowLong() Call that
           pt _           ' toggled the cbWndExtra bytes.  This call forces a
         )                'WM_PAINT message, just like you learned back in
         Call LineTo _  'Form2.bas.  When the WM_PAINT message comes through
         ( _            'what the program's logic must do is interrogate those
           hDC, _       'cbWndExtra bytes to determine whether a %TRUE or a
           rc.nRight, _ '%FALSE value is stored there.  If it finds a %TRUE
           rc.nBottom _ 'there program must draw an 'X across the window
         )              'extremities. If it finds a %FALSE there, it simply
         Call MoveToEx _'repaints the window blank, thereby removing anything
         ( _            'that might have been there.  Note the PAINTSTRUCT, RECT
           hDC, _       'and POINTAPI types used in the WM_PAINT processing. You
           0, _         'need to understand what these are, where you can find
           rc.nBottom, _'them, and how they are used.  These are types required
           pt _         'by Windows API calls.  They can be found in
         )              'Win32Api.inc. You can learn how they are used by
         Call LineTo(hDC,rc.nRight,0)  'looking them up and studying this
      End If                 'tutorial.
      Call EndPaint(hWnd,ps)
      fnChildWndProc=0
      Exit Function
  End Select  '
              '
  fnChildWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function fnMainWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static hChild() As Dword    'The storage class of 'static' will create this
  Register i As Long          'variable in the program's data segment, which has
  Register j As Long          'a duration' extending for the life time of the
                              'program, however, its 'scope' is limited to this
  Select Case As Long wMsg    'procedure or any procedures to which it is passed
    Case %WM_CREATE           'from this procedure.
      Local lpCreateStruct As CREATESTRUCT Ptr
      Local szClassName As Asciiz*16
      Local wc As WNDCLASSEX
      Local hInst As Dword
      Local k As Dword
      Redim hChild(5,5)
      lpCreateStruct=lParam
      hInst=@lpCreateStruct.hInstance
      szClassName="Child" 'Windows Will Recognize This Window Class As 'Child'
      wc.lpszClassName=VarPtr(szClassName) 'Assign Pointer To lpszClassName
      wc.cbSize=SizeOf(wc)                 'Member Of WNDCLASSEX
      wc.style=%CS_HREDRAW Or %CS_VREDRAW
      wc.lpfnWndProc=CodePtr(fnChildWndProc) 'Pointer To Window Procedure For
      wc.cbClsExtra=0                        'All Windows Of Class 'Child
      wc.cbWndExtra=4                        'Four Extra Bytes To Hold Boolean
      wc.hInstance=hInst                     'True/False Value
      wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
      wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
      wc.hbrBackground=GetStockObject(%WHITE_BRUSH)
      wc.lpszMenuName=%NULL
      Call RegisterClassEx(wc)  'Register 'Child' Window Class.  Create 5 X 5
      For i=0 To %GRID_SIZE-1   '(GRID_SIZE) Grid Of 'Child' Windows On Main
        For j=0 To %GRID_SIZE-1 'Window. Main Window Is The Parent Of Each Child
          hChild(i,j)=CreateWindow("Child","",%WS_CHILD Or %WS_VISIBLE Or %WS_BORDER,0,0,0,0,hWnd,k,hInst,ByVal 0)
          Incr k
        Next j
      Next i
      fnMainWndProc=0
      Exit Function
    Case %WM_SIZE                       'A WM_SIZE Msg Will Come Through The
      Local cxBlock,cyBlock As Long     'Main WndProc After The WM_CREATE.  As
      cxBlock=Lowrd(lParam)/%GRID_SIZE  'You Learned Back In Form2.bas, When A
      cyBlock=Hiwrd(lParam)/%GRID_SIZE  'WM_SIZE Msg Comes Through, The lParam
      For i=0 To %GRID_SIZE-1           'Will Contain the Window Height And
        For j=0 To %GRID_SIZE-1         'Width In Its Hi And Lo Order Words.  At
          Call MoveWindow(hChild(j,i),j*cxBlock,i*cyBlock,cxBlock,cyBlock,%TRUE)
        Next j         'This Point The Child Windows Are Assigned The Correct
      Next i           'Dimensions Through A Call To MoveWindow().  Check This
      fnMainWndProc=0  'Out In Your Api Reference!
      Exit Function
    Case %WM_DESTROY
      Call PostQuitMessage(0)
      fnMainWndProc=0
      Exit Function
  End Select

  fnMainWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function

Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local szAppName As Asciiz*16
  Local wc As WndClassEx
  Local Msg As tagMsg
  Local hWnd As Dword

  szAppName="Checkers"                             : wc.lpszClassName=VarPtr(szAppName)
  wc.lpfnWndProc=CodePtr(fnMainWndProc)            : wc.hInstance=hIns
  wc.cbSize=SizeOf(wc)                             : wc.style=%CS_HREDRAW Or %CS_VREDRAW
  wc.cbClsExtra=0                                  : wc.cbWndExtra=0
  wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION) : wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  wc.hbrBackground=GetStockObject(%WHITE_BRUSH)    : wc.lpszMenuName=%NULL
  wc.hIconSm=LoadIcon(hIns, ByVal %IDI_APPLICATION)
  Call RegisterClassEx(wc)
  hWnd=CreateWindow(szAppName,"Checkers",%WS_OVERLAPPEDWINDOW,200,100,525,450,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend

  Function=msg.wParam
End Function


''PowerBASIC adaptation of Charles Petzold's Checkers3 program from his
''Programming Windows 95' book.  This program creates a five by five grid of 25
'#Compile Exe "Checkers"  'child windows on the surface of a parent 'main'
'#Include "Win32api.inc"  'window.  When you left mouse button click on any
'%GRID_SIZE = 5           'window in the grid the program draws a big X across
'                         'the window.  The X is removed by clicking again.

'Function fnChildWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
'  Select Case As Long wMsg
'    Case %WM_CREATE
'      Call SetWindowLong _   'This is the Window Procedure for all windows of
'      ( _                    'the class 'Child'  In this program 25 such
'        hWnd, _              'windows are created in a loop down in the Window
'        0, _                 'Procedure for the Main Window (fnMainWndProc).
'        0 _                  'Every CreateWindow() Call there will cause a
'      )                      'WM_CREATE message to be sent here.  This procedure
'      fnChildWndProc=0       'will then receive 25 WM_CREATE messages.  When the
'      Exit Function          'Window Class for these windows was registered down
'    Case %WM_LBUTTONDOWN     'in fnMainWndProc(), the cbWndExtra bytes member of
'      Call SetWindowLong _   'the WNDCLASSEX type was set equal to four.  What
'      ( _                    'this means is that every window of this class
'        hWnd, _              'created will have a four byte area to store
'        0, _                 'something pertaining to the program's use of the
'        1 Xor GetWindowLong(hWnd,0) _ 'window.'What this program is going to do
'      )                      'with those four bytes is store a simple %TRUE /
'      Call InvalidateRect _  '%FALSE (1/0) value there that represents whether
'      ( _                    'the window has an 'X' in it or not.  When the
'        hWnd, _        'program starts up all the windows are to be empty.
'        Byval %NULL, _ 'Therefore, in the WM_CREATE processing the Api function
'        %TRUE _        'SetWindowLong() is used to store a value of zero in this
'      )                'four byte area'for each window.  When you click your
'      fnChildWndProc=0 'mouse button over a window this procedure will receive
'      Exit Function    'a WM_LBUTTONDOWN message with the hWnd parameter
'    Case %WM_PAINT     'reflecting the window which received the mouse click.
'      Local hDC As Dword     'At that point what the program must do is 'toggle'
'      Local ps As PAINTSTRUCT'whatever value is present in the cbWndExtra bytes
'      Local rc As RECT       'to its opposite. If true, we'll want to toggle to
'      Local pt As POINTAPI   'false.  If false,we'll want to toggle to true.  If
'      hDC=BeginPaint(hWnd,ps)'1' is Xor'ed with the XOR bit wise operator
'      Call GetClientRect(hWnd,rc)   'against '0', the result is 1.  If '1' is
'      If GetWindowLong(hWnd,0) Then 'Xor'ed against '1', theresult is '0'.  You
'         pt.x=0 : pt.y=0            'can see that done in the GetWindowLong()
'         Call MoveToEx _  'call within the SetWindowLong() call in the
'         ( _              'WM_LBUTTONDOWN processing.  What then finally causes
'           hDC, _         'the big 'X' to criss-cross the child window over
'           0, _           'which a mouse click occurs is the InvalidateRect()
'           0, _           'call directly after the SetWindowLong() Call that
'           pt _           ' toggled the cbWndExtra bytes.  This call forces a
'         )                'WM_PAINT message, just like you learned back in
'         Call LineTo _  'Form2.bas.  When the WM_PAINT message comes through
'         ( _            'what the program's logic must do is interrogate those
'           hDC, _       'cbWndExtra bytes to determine whether a %TRUE or a
'           rc.nRight, _ '%FALSE value is stored there.  If it finds a %TRUE
'           rc.nBottom _ 'there program must draw an 'X accross the window
'         )              'extremities. If it finds a %FALSE there, it simply
'         Call MoveToEx _'repaints the window blank, thereby removing anything
'         ( _            'that might have been there.  Note the PAINTSTRUCT, RECT
'           hDC, _       'and POINTAPI types used in the WM_PAINT processing. You
'           0, _         'need to understand what these are, where you can find
'           rc.nBottom, _'them, and how they are used.  These are types required
'           pt _         'by Windows API calls.  They can be found in
'         )              'Win32Api.inc. You can learn how they are used by
'         Call LineTo(hDC,rc.nRight,0)  'looking them up and studying this
'      End If                 'tutorial.
'      Call EndPaint(hWnd,ps)
'      fnChildWndProc=0
'      Exit Function
'  End Select  '
'              '
'  fnChildWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
'End Function


'Function fnMainWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
'  Static hChild() As Dword    'The storage class of 'static' will create this
'  Register i As Long          'variable in the program's data segment, which has
'  Register j As Long          'a duration' extending for the life time of the
'                              'program, however, its 'scope' is limited to this
'  Select Case As Long wMsg    'procedure or any procedures to which it is passed
'    Case %WM_CREATE           'fromthis procedure.
'      Local lpCreateStruct As CREATESTRUCT Ptr
'      Local szClassName As Asciiz*16
'      Local wc As WNDCLASSEX
'      Local hInst As Dword
'      Local k As Dword
'      Redim hChild(5,5)
'      lpCreateStruct=lParam
'      hInst=@lpCreateStruct.hInstance
'      szClassName="Child" 'Windows Will Recognize This Window Class As 'Child'
'      wc.lpszClassName=VarPtr(szClassName) 'Assign Pointer To lpszClassName
'      wc.cbSize=SizeOf(wc)                 'Member Of WNDCLASSEX
'      wc.style=%CS_HREDRAW Or %CS_VREDRAW
'      wc.lpfnWndProc=CodePtr(fnChildWndProc) 'Pointer To Window Procedure For
'      wc.cbClsExtra=0                        'All Windows Of Class 'Child
'      wc.cbWndExtra=4                        'Four Extra Bytes To Hold Boolean
'      wc.hInstance=hInst                     'True/False Value
'      wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
'      wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
'      wc.hbrBackground=GetStockObject(%WHITE_BRUSH)
'      wc.lpszMenuName=%NULL
'      Call RegisterClassEx(wc)  'Register 'Child' Window Class.  Create 5 X 5
'      For i=0 To %GRID_SIZE-1   '(GRID_SIZE) Grid Of 'Child' Windows On Main
'        For j=0 To %GRID_SIZE-1 'Window. Main Window Is The Parent Of Each Child
'          hChild(i,j)=CreateWindow("Child","",%WS_CHILD Or %WS_VISIBLE Or %WS_BORDER,0,0,0,0,hWnd,k,hInst,ByVal 0)
'          Incr k
'        Next j
'      Next i
'      fnMainWndProc=0
'      Exit Function
'    Case %WM_SIZE                       'A WM_SIZE Msg Will Come Through The
'      Local cxBlock,cyBlock As Long     'Main WndProc After The WM_CREATE.  As
'      cxBlock=Lowrd(lParam)/%GRID_SIZE  'You Learned Back In Form2.bas, When A
'      cyBlock=Hiwrd(lParam)/%GRID_SIZE  'WM_SIZE Msg Comes Through, The lParam
'      For i=0 To %GRID_SIZE-1           'Will Contain the Window Height And
'        For j=0 To %GRID_SIZE-1         'Width In Its Hi And Lo Order Words.  At
'          Call MoveWindow(hChild(j,i),j*cxBlock,i*cyBlock,cxBlock,cyBlock,%TRUE)
'        Next j         'This Point The Child Windows Are Assigned The Correct
'      Next i           'Dimensions Through A Call To MoveWindow().  Check This
'      fnMainWndProc=0  'Out In Your Api Reference!
'      Exit Function
'    Case %WM_DESTROY
'      Call PostQuitMessage(0)
'      fnMainWndProc=0
'      Exit Function
'  End Select

'  fnMainWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
'End Function

'Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
'  Local szAppName As Asciiz*16
'  Local wc As WndClassEx
'  Local Msg As tagMsg
'  Local hWnd As Dword

'  szAppName="Checkers"                             : wc.lpszClassName=VarPtr(szAppName)
'  wc.lpfnWndProc=CodePtr(fnMainWndProc)            : wc.hInstance=hIns
'  wc.cbSize=SizeOf(wc)                             : wc.style=%CS_HREDRAW Or %CS_VREDRAW
'  wc.cbClsExtra=0                                  : wc.cbWndExtra=0
'  wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION) : wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
'  wc.hbrBackground=GetStockObject(%WHITE_BRUSH)    : wc.lpszMenuName=%NULL
'  wc.hIconSm=LoadIcon(hIns, ByVal %IDI_APPLICATION)
'  Call RegisterClassEx(wc)
'  hWnd=CreateWindow(szAppName,"Checkers",%WS_OVERLAPPEDWINDOW,200,100,525,450,0,0,hIns,ByVal 0)
'  Call ShowWindow(hWnd,iShow)
'  While GetMessage(Msg,%NULL,0,0)
'    Call TranslateMessage(Msg)
'    Call DispatchMessage(Msg)
'  Wend

'  Function=msg.wParam
'End Function
