#Compile Exe  "CreateStruct"      'CreateStruct.bas
#Include      "Win32api.inc"
'Labels
%IDC_LABEL1   = 1500        'These are equates and serve as
%IDC_LABEL2   = 1505        'control identifiers for the
%IDC_LABEL3   = 1510        'various controls used in a
%IDC_LABEL4   = 1515        'program.  This particular program
%IDC_LABEL5   = 1520        'only has one main window that
%IDC_LABEL6   = 1525        'contains nine labels and nine
%IDC_LABEL7   = 1530        'text boxes (edit controls).  You
%IDC_LABEL8   = 1535        'don't need to make window handles
%IDC_LABEL9   = 1540        'global in a program because if
                            'you know a control's parent and
'Edit Controls              'its control id you can get its
%IDC_EDIT1    = 1550        'window handle through a call tp
%IDC_EDIT2    = 1555        'GetDlgItem(hParent,%CONTROL_ID)
%IDC_EDIT3    = 1560
%IDC_EDIT4    = 1565
%IDC_EDIT5    = 1570
%IDC_EDIT6    = 1575
%IDC_EDIT7    = 1580
%IDC_EDIT8    = 1585
%IDC_EDIT9    = 1590

Type WndEventArgs               'Type for passing window procedure parameters.
  wParam           As Long      'Allows me to shorten parameter list.  .NET does
  lParam           As Long      'this all the time.  See, for example pea for
  hWnd             As Dword     'PaintEventArgs in the OnPaint()Message Handler.
End Type


Type MyUserData                 'Here is a type I created just to show you how to pass
  iAnyOldInt       As Long      'control/program specific user data from a point in a
  szAnyOldString   As Asciiz*32 'program where a CreateWindowEx() call is being made to
End Type                        'the location in a program where the WndProc() resides

Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local lpCreateStruct As CREATESTRUCT Ptr
  Local ptrMud As MyUserData Ptr
  Local hCtrl As Dword                        'Right here we are in a message
  Local hInst As Dword                        'handler for the %WM_CREATE
                                              'message, and the %WM_CREATE
  lpCreateStruct=Wea.lParam                   'message will only be received
  hInst=@lpCreateStruct.hInstance             'once for each window that is
  ptrMud=@lpCreateStruct.lpCreateParams       'being created.  In other words,
                                              'there is a one to one relationship
  hCtrl= _       'First Label                 'between a CreateWindow() Call and
  CreateWindowEx _                            'a %WM_CREATE message.  The last
  ( _                                         'parameter in the Window Procedure
    0, _                                      'is lParam.  It was transported
    "static", _                               'here as part of the WndEventArgs
    "@lpCreateStruct.@lpszName", _            'type - Wea.lParam.  This
    %WS_CHILD Or %WS_VISIBLE, _               'parameter's meaning during a
    10,10,200,25, _                           'WM_CREATE message is a pointer to
    Wea.hWnd, _                               'a CREATESTRUCT type that Windows
    %IDC_LABEL1, _                            'itself filled out at the time of
    hInst, _                                  'the CreateWindowEx() call down in
    Byval 0 _                                 'WinMain.  The way we 'get at' that
  )                                           'data here is to declare a pointer
                                              'to a CREATESTRUCT type.  You will
  hCtrl= _       'First edit                  'be able to find this type in
  CreateWindowEx _                            'Win32Api.inc. Note the very first
  ( _                                         'local variable in this procedure
    %WS_EX_CLIENTEDGE, _                      'Local lpCreateStruct As CREATESTRUCT ptr.
    "Edit", _                                 'You'll note the very first line
    @lpCreateStruct.@lpszName, _              'in this procedure sets this
    %WS_CHILD Or %WS_VISIBLE, _               'variable to the address contained
    220,10,200,25, _                          'in Wea.lParam.  At this point then
    Wea.hWnd, _                               'we are able to access every member
    %IDC_EDIT1, _                             'of this type here because
    hInst, _                                  'PowerBASIC knows how a CREATESTRUCT
    Byval 0 _                                 'is laid out, and so can access
  )                                           'its member variables through an
                                              'ordinary variable of this type,
  hCtrl= _       'Second Label                'or through a pointer to this type
  CreateWindowEx _                            'as is the case here.  Further,
  ( _                                         'the first field or member
    0, _                                      'variable of the CREATESTRUCT
    "static", _                               'type is itself a pointer
    "@lpCreateStruct.@lpszClass", _           'lpCreateParams'.  Down in
    %WS_CHILD Or %WS_VISIBLE, _               'WinMain() a variable of type
    10,45,200,25, _                           'MyUserData was declared and
    Wea.hWnd, _                               'member iAnyOldInt was set to
    %IDC_LABEL2, _                            '12345 and member szAnyOldString
    hInst, _                                  'was set equal to "Any Old String".
    Byval 0 _                                 'The variable itself was named
  )                                           'mud which is short for MyUserData.
  'The term Varptr(mud) was placed in the last parameter of the CreateWindowEx()
  'call, and this of course would be the address of that variable - which is a
  'pointer.
  hCtrl= _       'Second edit                 'So, that address will show up
  CreateWindowEx _                            'here in fnWndProc_OnCreate() as
  ( _                                         'the first member variable of the
    %WS_EX_CLIENTEDGE, _                      'CREATESTRUCT type pointed to by
    "Edit", _                                 'the Wea.lParam variable. That
    @lpCreateStruct.@lpszClass, _             'does sound rather complicated but
    %WS_CHILD Or %WS_VISIBLE, _               'it really doesn't have to be
    220,45,200,25, _                          'unless you make it so!  You will
    Wea.hWnd, _                               'note though that we did have to
    %IDC_EDIT2, _                             'create a pointer to a MyUserData
    hInst, _                                  'type to get at this information
    Byval 0 _                                 'just as we had to create a pointer
  )                                           'to a CREATESTRUCT to get at the
                                              'overall containing type. Although
                                              'this program looks long it is very
  hCtrl= _       'Third Label                 'repetitious in that most of it is
  CreateWindowEx _                            'just code for creating nine
  ( _                                         'labels and nine textboxes. That's
    0, _                                      'what all this code over at the
    "static", _                               'left is about.  It shouldn't be
    "@lpCreateStruct.hInstance", _            'anything you don't understand at
    %WS_CHILD Or %WS_VISIBLE, _               'this point if you have followed
    10,80,200,25, _                           'my tutorials up to this point.
    Wea.hWnd, _                               'One thing I did here that I'd
    %IDC_LABEL3, _                            'like to finally point out to you
    hInst, _                                  'because I feel it may contain
    Byval 0 _                                 'possibilities for confusion
  )                                           'concerns the difference between
                                              'accessing a character string
  hCtrl= _       'Third edit                  'contained within a user defined
  CreateWindowEx _                            'type and accessing a character
  ( _                                         'string through a pointer member
    %WS_EX_CLIENTEDGE, _                      'of a user defined type.  Note that
    "Edit", _                                 'the very first bit of info that
    Str$(@lpCreateStruct.hInstance), _        'displays on the program's Form
    %WS_CHILD Or %WS_VISIBLE, _               'is the name of the app which is
    220,80,200,25, _                          'defined down in WinMain as
    Wea.hWnd, _                               '"CreateStruct".  It is accessed
    %IDC_EDIT3, _                             'here through the term -                                              '
    hInst, _                                  '@lpCreateStruct.@lpszName.  The
    Byval 0 _                                 'reason for the first '@' symbol
  )                                           'is because lpCreateStruct is a
  'pointer and we want what is stored at the address held in the pointer. The
  'reason for the 2nd '@' symbol is exactly the same.  The lpszName member of
  'the type doesn't hold a string
  hCtrl= _                                    'but rather a pointer to a string.
  CreateWindowEx _                            'Contrast this with the MyUserData
  ( _                                         'type I created for this program.
    0, _                                      'If you look at the 2nd member of
    "static", _                               'this type you'll see the variable
    "@lpCreateStruct.cx", _                   'szAnyOldString As Asciiz*32.  In
    %WS_CHILD Or %WS_VISIBLE, _               'this case the string contains 32
    10,115,200,25, _                          'bytes of space where a string of
    Wea.hWnd, _                               'up to 31 characters plus a null
    %IDC_LABEL4, _                            'byte may be stored.  This is
    hInst, _                                  'entirely different from the
    Byval 0 _                                 'lpszName and lpszClass member
  )                                           'variables of the CREATESTRUCT type
                                              'where each of these two variables
  hCtrl= _       'Fourth edit                 'only occupies 4 bytes - just
  CreateWindowEx _                            'enough for a 32 bit pointer on 32
  ( _                                         'bit systems.  So you see a type
    %WS_EX_CLIENTEDGE, _                      'can actually hold memory to
    "Edit", _                                 'contain an Asciiz string, or it
    Str$(@lpCreateStruct.cx), _               'can contain just a pointer member
    %WS_CHILD Or %WS_VISIBLE, _               'that contains just the integer
    220,115,200,25, _                         'address of a string stored
    Wea.hWnd, _                               'somewhere else.  If a user defined
    %IDC_EDIT4, _                             'type actually stores the whole
    hInst, _                                  'string itself it is accessed like
    Byval 0 _                                 'so - @ptrMud.szAnyOldString. No
  )                                           '2nd '@' symbol is needed.  If,
  'however, the type only contains a pointer to a string stored somewhere else
  'then the 2nd '@' symbol is needed - @lpCreateStruct.@lpszName.

  hCtrl= _
  CreateWindowEx _
  ( _
    0, _
    "static", _
    "@lpCreateStruct.cy", _
    %WS_CHILD Or %WS_VISIBLE, _
    10,150,200,25, _
    Wea.hWnd, _
    %IDC_LABEL5, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _
    "Edit", _
    Str$(@lpCreateStruct.cy), _
    %WS_CHILD Or %WS_VISIBLE, _
    220,150,200,25, _
    Wea.hWnd, _
    %IDC_EDIT5, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    0, _
    "static", _
    "@lpCreateStruct.x", _
    %WS_CHILD Or %WS_VISIBLE, _
    10,185,200,25, _
    Wea.hWnd, _
    %IDC_LABEL6, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _
    "Edit", _
    Str$(@lpCreateStruct.x), _
    %WS_CHILD Or %WS_VISIBLE, _
    220,185,200,25, _
    Wea.hWnd, _
    %IDC_EDIT6, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    0, _
    "static", _
    "@lpCreateStruct.y", _
    %WS_CHILD Or %WS_VISIBLE, _
    10,220,200,25, _
    Wea.hWnd, _
    %IDC_LABEL7, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _
    "Edit", _
    Str$(@lpCreateStruct.y), _
    %WS_CHILD Or %WS_VISIBLE, _
    220,220,200,25, _
    Wea.hWnd, _
    %IDC_EDIT7, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    0, _
    "static", _
    "@ptrMud.iAnyOldInt", _
    %WS_CHILD Or %WS_VISIBLE, _
    10,255,200,25, _
    Wea.hWnd, _
    %IDC_LABEL8, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _
    "Edit", _
    Str$(@ptrMud.iAnyOldInt), _
    %WS_CHILD Or %WS_VISIBLE, _
    220,255,200,25, _
    Wea.hWnd, _
    %IDC_EDIT8, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    0, _
    "static", _
    "@ptrMud.szAnyOldString", _
    %WS_CHILD Or %WS_VISIBLE, _
    10,290,200,25, _
    Wea.hWnd, _
    %IDC_LABEL9, _
    hInst, _
    Byval 0 _
  )

  hCtrl= _
  CreateWindowEx _
  ( _
    %WS_EX_CLIENTEDGE, _
    "Edit", _
    @ptrMud.szAnyOldString, _
    %WS_CHILD Or %WS_VISIBLE, _
    220,290,200,25, _
    Wea.hWnd, _
    %IDC_EDIT9, _
    hInst, _
    Byval 0 _
  )

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnDestroy(Wea As WndEventArgs) As Long
  Call PostQuitMessage(0)
  fnWndProc_OnDestroy=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local Wea As WndEventArgs

  Select Case As Long wMsg
    Case %WM_CREATE
      Wea.hWnd=hWnd : Wea.wParam=wParam : Wea.lParam=lParam
      fnWndProc=fnWndProc_OnCreate(Wea)
      Exit Function
    Case %WM_DESTROY
      Call PostQuitMessage(0)
      fnWndProc=fnWndProc_OnDestroy(Wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local winclass As WndClassEx
  Local szAppName As Asciiz*16
  Local mud As MyUserData
  Local Msg As tagMsg
  Local hWnd As Dword

  mud.iAnyOldInt=12345                       'We've declared a type variable of MyUserData just above
  mud.szAnyOldString="Any Old String"        'named 'mud', which is short for MyUserData.  It contains
  szAppName="Pointers"                       'an arbitrary integer and an arbitrary string so as to
  winclass.cbSize=SizeOf(winclass)           'show how to pass window creation data to a window
  winclass.style=%CS_HREDRAW Or %CS_VREDRAW  'procedure through a CreateWindowEx() call.  Up in
  winclass.lpfnWndProc=CodePtr(fnWndProc)    'fnWndProc_OnCreate() I give a detailed explanation of
  winclass.cbClsExtra=0                      'how this information is extracted there.  Note the last
  winclass.cbWndExtra=0                      'parameter of the CreateWindowEx() call contains the term
  winclass.hInstance=hIns                    'VarPtr(mud).  This is how the address of this data is being
  winclass.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)    'passed to the Window Procedure
  winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  winclass.hbrBackground=%COLOR_BTNFACE+1
  winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)
  winclass.hIconSm=LoadIcon(hIns, ByVal %IDI_APPLICATION)
  RegisterClassEx winclass
  hWnd=CreateWindow(szAppName,"CreateStruct",%WS_OVERLAPPEDWINDOW,200,100,445,360,0,0,hIns,Varptr(mud))
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
