#Compile Exe  "Label5"         'Shows how to create a very simple
#Include "Win32api.inc"        'custom control through the use
%IDC_LABEL1 = 1500             'of cbWndExtra bytes, pointers, and
%IDC_LABEL2 = 1505             'dynamic memory allocation through
%IDC_EDIT1  = 1510             'the use of HeapAlloc() and HeapFree().
%IDC_EDIT2  = 1515

Function fnLabelWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local pszStr As Asciiz Ptr
  Local hHeap As Dword

  Select Case As Long wMsg
    Case %WM_CREATE
      Local lpCS As CREATESTRUCT Ptr    'First declare CREATESTRUCT ptr to get
      Local szCaption As Asciiz*64      'CreateWindowEx() parameters.  Then
      lpCS=lParam                       'get address of CREATESTRUCT from
      szCaption=@lpCS.@lpszName         'lParam.  The caption we want for the
      hHeap=GetProcessHeap()            'label is stored by the compiler at
      pszStr= _                         '@lpszName.  We need to then allocate
      HeapAlloc _                       'enough memory to store the caption
      ( _                               'plus a null terminator.  Once we do
        hHeap, _                        'obtain a pointer to the memory from
        %HEAP_ZERO_MEMORY, _            'HeapAlloc() we need to copy the Asci
        Len(szCaption)+1 _              'bytes to the allocated location with
      )                                 'Poke$ (test to be sure the memory
      If pszStr Then                    'allocation was successful). Providing
         Poke$ Asciiz,pszStr,szCaption  'all is well, store the pointer to the
         Call SetWindowLong _           'allocated memory in the four byte
         ( _                            'area we set aside for it in the
           hWnd, _                      'cbWndExtra bytes when we created the
           0, _                         'class down in fnWndProc().  If the
           pszStr _                     'memory can't be allocated return a
         )                              '-1 from fnLabelWndProc() and the
      Else                              'CreateWindowEx() call down in
         fnLabelWndProc=-1              'fnWndProc will return a null handle
         Exit Function                  'and logic there can deal with ending
      End If                            'the program.
      fnLabelWndProc=0
      Exit Function
    Case %WM_PAINT
      Local lpPaint As PAINTSTRUCT      'When a label receives this message it
      Local hDC As Long                 'must paint itself.  In other words,
      hDC=BeginPaint(hWnd,lpPaint)      'it must draw its caption.  Before it
      Call SetBkMode(hDC,%TRANSPARENT)  'can do that it must find out what its
      pszStr=GetWindowLong(hWnd,0)      'caption is.  It 'knows' that a pointer
      Call TextOut _                    'to its caption string is stored at
      ( _                               'byte offset 0 in its cbWndExtra bytes.
        hDC, _                          'So all it has to do is retrieve that
        0, _                            'pointer and pass it to TextOut()
        0, _
        @pszStr, _
        Len(@pszStr) _
       )
      Call EndPaint(hWnd,lpPaint)
      fnLabelWndProc=0
      Exit Function                     'Memory that is allocated from the heap
    Case %WM_DESTROY                    'should be restored when it is no
      pszStr=GetWindowLong(hWnd,0)      'longer needed.  Since this program has
      hHeap=GetProcessHeap()            'created two labels, this fnLabelWndProc
      Call HeapFree(hHeap,0,pszStr)     'will receive a WM_DESTROY message for
      fnLabelWndProc=0                  'each one, so HeapFree() will be called
      Exit Function                     'twice here, once for each label.
  End Select

  fnLabelWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CREATE
      Local hLbl1 As Dword, hLbl2 As Dword
      Local hEdit1 As Dword, hEdit2 As Dword,hInst As Dword
      Local lpCreateStruct As CREATESTRUCT Ptr
      Local szClassName As Asciiz*16
      Local wc As WndClassEx
      lpCreateStruct=lParam
      hInst=@lpCreateStruct.hInstance
      szClassName="MyLabel"                             'Here is where we will
      wc.lpfnWndProc=CodePtr(fnLabelWndProc)            'create a window class
      wc.lpszClassName=VarPtr(szClassName)              'for our custom label
      wc.style=%CS_HREDRAW Or %CS_VREDRAW               'control.  We will have
      wc.cbClsExtra=0                                   'to provide a window
      wc.cbWndExtra=4                                   'procedure for our
      wc.hInstance=hInst                                'label control, and
      wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)  'we'll set aside four
      wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)    'bytes in the cbWndExtra
      wc.hbrBackground=%COLOR_BTNFACE+1                 'bytes for a pointer to
      wc.lpszMenuName=%NULL                             'the label's text.
      wc.cbSize=SizeOf(wc)
      Call RegisterClassEx(wc)

      'Make Label1
      hLbl1= _                         'We'll create our custom label control
      CreateWindowEx _                 'in exactly the same manner as any other
      ( _                              'windows control, that is, with a
        0, _                           'CreateWindowEx() function call.  Note
        "MyLabel", _                   'that the 2nd parameter in this call is
        "Label1", _                    'the class of control to create.  Here
        %WS_CHILD Or %WS_VISIBLE, _    'we'll just put "MyLabel", and since the
        20,10,50,20, _                 'class has been Registered, Windows will
        hWnd, _                        'go about instantiating it just the same
        %IDC_LABEL1, _                 'as it would for any of the classes
        hInst, _                       'which are internal to it such as edit
        ByVal 0 _                      'controls or list boxes.  To prove this
      )                                'to yourself just compare this call to
                                       'the one below that creates an edit
      'Make Label2                     'control.
      hLbl2=CreateWindowEx( _
        0, _
        "MyLabel", _
        "Label2", _
        %WS_CHILD Or %WS_VISIBLE, _
        20,50,50,20, _
        hWnd, _
        %IDC_LABEL2, _
        hInst, _
        ByVal 0 _
      )

      'Make Edit1  (text box #1)
      hEdit1=CreateWindowEx( _
        %WS_EX_CLIENTEDGE, _
        "Edit", _
        "Edit1", _
        %WS_CHILD Or %WS_VISIBLE Or %ES_AUTOHSCROLL, _
        80,10,150,20, _
        hWnd, _
        %IDC_EDIT1, _
        GetWindowLong(hWnd,%GWL_HINSTANCE), _
        ByVal 0 _
      )

      'Make Edit2  (text box #2)
      hEdit2=CreateWindowEx( _
        %WS_EX_CLIENTEDGE, _
        "Edit", _
        "Edit2", _
        %WS_CHILD Or %WS_VISIBLE Or %ES_AUTOHSCROLL, _
        80,50,150,20, _
        hWnd, _
        %IDC_EDIT2, _
        GetWindowLong(hWnd,%GWL_HINSTANCE), _
        ByVal 0 _
      )
      fnWndProc=0
      Exit Function
    Case %WM_DESTROY
      Call PostQuitMessage(0)
      fnWndProc=0
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local winclass As WndClassEx
  Local szAppName As Asciiz*16
  Local Msg As tagMsg
  Local hWnd As Dword

  szAppName="Label5"
  winclass.cbSize=SizeOf(winclass)
  winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.lpfnWndProc=CodePtr(fnWndProc)
  winclass.cbClsExtra=0
  winclass.cbWndExtra=0
  winclass.hInstance=hIns
  winclass.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  winclass.hbrBackground=%COLOR_BTNFACE+1
  winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)
  Call RegisterClassEx(winclass)
  hWnd=CreateWindow(szAppName,"Label5",%WS_OVERLAPPEDWINDOW,200,100,325,150,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
