#Compile Exe   "SQLDrivers"
#Dim All
#Include "Win32Api.inc"

%SQL_NULL_HANDLE         = 0&    'Note!  These eight equates and four functions
%SQL_HANDLE_ENV          = 1     'I abstracted from the PB ODBC includes at
%SQL_ATTR_ODBC_VERSION   = 200   'http://www.powerbasic.com/files/pub/pbwin/database/pbodbc30.zip
%SQL_OV_ODBC3            = 3???  'I didn't want to force you to download these
%SQL_IS_INTEGER          = (-6)  'files just to get this tutorial program to
%SQL_FETCH_NEXT          = 1     'work.  However, if you are interested in
%SQL_NO_DATA             = 100   'learning to use ODBC function calls I'd recom-
%SQL_ERROR               = -1    'mend you download the ODBC includes.

Declare Function SQLAllocHandle Lib "ODBC32.DLL" Alias "SQLAllocHandle" _
( _
  ByVal HandleType          As Integer,_
  ByVal InputHandle         As Dword,_
  ByRef OutPutHandle        As Dword _
) As Integer


Declare Function SQLSetEnvAttr Lib "ODBC32.DLL" Alias "SQLSetEnvAttr" _
( _
  ByVal EnvironmentHandle   As Dword,_
  ByVal Attribute           As Long,_
  ByRef Value               As Any,_
  ByVal StringLength        As Long _
) As Integer


Declare Function SQLDrivers Lib "ODBC32.DLL" Alias "SQLDrivers" _
( _
  ByVal henv                As Dword,_
  ByVal fDirection          As Word,_
  ByRef szDriverDesc        As Asciiz,_
  ByVal cbDriverDescMax     As Integer,_
  ByRef pcbDriverDesc       As Integer,_
  ByRef szDriverAttributes  As Asciiz,_
  ByVal cbDrvrAttrMax       As Integer,_
  ByRef pcbDrvrAttr         As Integer _
) As Integer


Declare Function SQLFreeHandle Lib "ODBC32.DLL" Alias "SQLFreeHandle" _
( _
  ByVal HandleType          As Integer,_
  ByVal TheHandle           As Dword _
) As Integer


Macro Display(msg,fp)     'If program is running in Console Compiler, Output
  #If %Def(%Pb_Cc32)      'goes to StdOut of Console Window.
      StdOut msg
  #Else
      Print #fp, msg      'Otherwise, to a file which will be ShellExecut()'ed
  #EndIf                  'at program termination.
End Macro


Function PBMain() As Long
  Local iLen1 As Integer, iLen2 As Integer, fn As Integer
  Local szDriverDes As Asciiz*64, szDriverAttr As Asciiz*256
  Local szTextFile As Asciiz*256, szCurDir As Asciiz*256
  Local ptrByte As Byte Ptr
  Local strArr() As String
  Local hEnvr As Dword
  Register i As Long

  #If %Def(%Pb_Cc32)
      Console Set Screen 400, 80
  #Else
      szTextFile=CurDir$ & "\" & "Output.txt"
      fn=FreeFile
      Open szTextFile For Output As #fn
  #EndIf
  If SQLAllocHandle(%SQL_HANDLE_ENV,%SQL_NULL_HANDLE,hEnvr)<>%SQL_ERROR Then
     Call SQLSetEnvAttr(hEnvr,%SQL_ATTR_ODBC_VERSION,ByVal %SQL_OV_ODBC3,%SQL_IS_INTEGER)
     While SQLDrivers(hEnvr,%SQL_FETCH_NEXT,szDriverDes,64,iLen1,szDriverAttr,256,iLen2)<>%SQL_NO_DATA
       Display(szDriverDes,fn)
       Display(Chr$(13),fn)
       ptrByte=VarPtr(szDriverAttr)
       Decr iLen2
       For i=0 To iLen2
         If @ptrByte[i]=0 Then
            @ptrByte[i]=44
         End If
       Next i
       @ptrByte[iLen2]=0
       ReDim strArr(ParseCount(szDriverAttr)-1)
       Parse szDriverAttr,strArr()
       For i=0 To UBound(strArr,1)
         Display(strArr(i),fn)
       Next i
       Display(Chr$(13,10) & Chr$(13),fn)
     Loop
     Call SQLFreeHandle(%SQL_HANDLE_ENV,hEnvr)
  Else
     Display("ODBC Function Call Failure.  Couldn't Allocate Environment Handle!",fn)
  End If
  #If %Def(%Pb_Cc32)
      WaitKey$
  #Else
      Close #fn
      szCurDir=CurDir$
      Call ShellExecute(0,"Open",szTextFile,ByVal 0,szCurDir,%SW_SHOWDEFAULT)
  #EndIf

  PBMain=0
End Function
