#Compile Exe         "Ptrs2"      'Ptrs2.bas  Shows how to use function
#Dim All                          'pointers to call event/message procedures.
%WM_CREATE           = &H1        'Note I left out Win32Api.inc
%WM_MOUSEMOVE        = &H200      'and just copied these equates
%WM_LBUTTONDOWN      = &H201      'I needed from that file.
%WM_SIZE             = &H5
%WM_CHAR             = &H102
%WM_PAINT            = &HF
%WM_DESTROY          = &H2

Type MessageHandler               'This Type Associates a message with the
  wMessage As Long                'address of the message handler which
  fnPtr    As Dword               'handles it.  Messages are usually fairly
End Type                          'low numbers, e.g., WM_PAINT is 15.

Global MsgHdlr() As MessageHandler

Type WndEventArgs
  hWnd     As Dword
  wParam   As Long
  lParam   As Long
End Type

Declare Function fnPtr(wea As WndEventArgs) As Long  'Prototype will provide compiler with function signature

Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long         'WM_CREATE Message Handler
  Print "Just Called fnWndProc_OnCreate()!"
  Function=0
End Function

Function fnWndProc_OnMouseMove(Wea As WndEventArgs) As Long      'WM_MOUSEMOVE Message Handler
  Print "Just Called fnWndProc_OnMouseMove()!"
  Function=0
End Function

Function fnWndProc_OnSize(Wea As WndEventArgs) As Long           'WM_SIZE Message Handler
  Print "Just Called fnWndProc_OnSize()!"
  Function=0
End Function

Function fnWndProc_OnChar(Wea As WndEventArgs) As Long           'WM_CHAR Message Handler
  Print "Just Called fnWndProc_OnChar()!"
  Function=0
End Function

Function fnWndProc_OnLButtonDown(Wea As WndEventArgs) As Long    'WM_LBUTTONDOWN Message Handler
  Print "Just Called fnWndProc_OnLButtonDown()!"
  Function=0
End Function

Function fnWndProc_OnPaint(Wea As WndEventArgs) As Long          'WM_PAINT Message Handler
  Print "Just Called fnWndProc_OnPaint()!"
  Function=0
End Function

Function fnWndProc_OnDestroy(Wea As WndEventArgs) As Long        'WM_DESTROY Message Handler
  Print "Just Called fnWndProc_OnDestroy()!"
  Function=0
End Function

Sub AttachMessageHandlers()
  ReDim MsgHdlr(6) As MessageHandler

  MsgHdlr(0).wMessage=%WM_CREATE      : MsgHdlr(0).fnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_MOUSEMOVE   : MsgHdlr(1).fnPtr=CodePtr(fnWndProc_OnMouseMove)
  MsgHdlr(2).wMessage=%WM_SIZE        : MsgHdlr(2).fnPtr=CodePtr(fnWndProc_OnSize)
  MsgHdlr(3).wMessage=%WM_CHAR        : MsgHdlr(3).fnPtr=CodePtr(fnWndProc_OnChar)
  MsgHdlr(4).wMessage=%WM_LBUTTONDOWN : MsgHdlr(4).fnPtr=CodePtr(fnWndProc_OnLButtonDown)
  MsgHdlr(5).wMessage=%WM_PAINT       : MsgHdlr(5).fnPtr=CodePtr(fnWndProc_OnPaint)
  MsgHdlr(6).wMessage=%WM_DESTROY     : MsgHdlr(6).fnPtr=CodePtr(fnWndProc_OnDestroy)
End Sub

Function PBMain() As Long
  Local wea As WndEventArgs
  Local iReturn As Long
  Register i As Long

  Call AttachMessageHandlers()        'Attach Message Handlers
  For i=0 To UBound(MsgHdlr,1)        'Loop Through All Message Handlers
    Print i,;
    Call Dword MsgHdlr(i).fnPtr Using fnPtr(wea) To iReturn
  Next i
  Waitkey$

  PBMain=0
End Function
